\ adhoc beacon node
\ starts an adhoc network using a unique essid
\ no other node should join, so beacon should remain local
\ for creating a challenge environment on a specific channel
\ no TCP/IP support enabled
visible

d# 1 value adhoc-channel                  \ the channel to use (in decimal)
0 0 2value adhoc-network$

\ ------------------------------------------------------------------------------

: .mac  ( adr len -- )
   push-hex drop  5 0  do
      dup c@ (.2) type  ." :"  1+
   loop
   c@ (.2) type  pop-base
;

\ ------------------------------------------------------------------------------

: abn

   ." adhoc beacon node" cr
   ." v1.0 2014-02-10 quozl@laptop.org" cr cr

   ." choosing a local SSID   ... "
   " SN" find-tag 0= if                      \ serial number tag, or
      time&date >unix-seconds " %d" sprintf  \ equivalent of $(date +%s)
   then
   to adhoc-network$
   adhoc-network$ type cr

   ." opening wireless device ... "
   " /wlan:force" open-dev to wlan-ih        \ avoids automatic association
   wlan-ih 0= abort" Can't open wireless LAN"
   ." ok" cr

   ." check for MAC address   ... "
   " get-mac-address" $call-wlan .mac ."  ok" cr

   ." writing to USB drive    ... "
   collect(
      ." adhoc beacon node" cr
      time&date >unix-seconds " %d" printf  cr
      " get-mac-address" $call-wlan .mac cr
      adhoc-network$ type cr
      adhoc-channel .d cr
   )collect				( $text )

   \ delete file if already present
   make-sn-name 2dup ['] $delete catch if
      2drop
   then                                 ( $text $file )
   2dup type cr				( $text $file )
   $create-file dup 0= abort" Can't create file"
   >r " write" r@ $call-method r> close-dev ( )

   ." starting adhoc network  ... "
   adhoc-channel adhoc-network$ " adhoc-start" $call-wlan
   ." ok" cr

   \ continue processing device responses
   \ until user presses q
   ." listening" cr
   cr " test-antenna" $call-wlan cr cr

   ." stopping adhoc network  ... "
   " adhoc-stop" $call-wlan
   ." ok" cr

   ." closing wireless device ... "
   close-wlan
   ." ok" cr
   cr
;

abn
\ leave user at ok prompt with network off

\ FIXME: on XO-4 the adhoc network collapses eventually with Result = 1
